**--------------File Info---------------------------------------------------------------------------------
** File Name:               Main.c
** Last modified date:        2013-03-27
** Last version:             V1.0
** Description:              ?????
**
**--------------------------------------------------------------------------------------------------------
** Created by:              Yitao LU
** Created date:            2013-03-27
** Version:                 V1.0
** Descriptions:            ??????
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Descriptions:
*********************************************************************************/
#include "usb_deal.h"
#include "StepCount.h"
#include "KL25Z_Flash.h"
#include "KL25Z_RTC.h"

extern INT8U gucUSBInsertFlag;
extern INT8U gucUSBExtractFlag ;

INT8U gucUSBExtractCont = 0;
volatile INT8U gu8ISR_Flags=0;

/**********************************************************************************
** Function name:           main
** Descriptions:            ??????
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              Yitao LU
** Created Date:            2013-04-25
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**********************************************************************************/
int  main (void)
{
    SystemCoreClockUpdate();
    hmiModuleInit();                           	/* ???????		*/
    tsiModuleInit();                            	/* ?????????	*/
    rtcModuleInit();             				/* ???????		*/
    CountStepInit();              			/* ?????		*/
    userInitUSB();                    			/* USB???		*/
    userInitFlash();                  			/* Flash???		*/
    getStoreData();                   			/* ???????		*/
    
    while(1){       
        CountStep();                			/* ??????		*/
        keyProcess(menuIDGet());        		/* ??????		*/
        usbMsgDeal();                     		/* USB??????	*/
        getHumitureValue();              		/* ???????		*/
        systemStatusContorl();                  	/* ????????	*/
        if (gucUSBInsertFlag == 0) {
            systemStatusContorl();
        } else {
            usSystemStatusTimeCont = 0;
        }
        if (gucUSBExtractCont == 1 && gucUSBInsertFlag == 1) {
            gucUSBExtractCont = 0;
            if (gucUSBExtractFlag == 0) {
                gucUSBInsertFlag = 0;
            }
            gucUSBExtractFlag = 0;
        }
    }
}
/**********************************************************************************
  END FILE
*********************************************************************************/

????2  KL25Z_IT.c
**--------------File Info---------------------------------------------------------------------------------
** File name:               TSI_ISR.c
** Last modified date:      2013-03-27
** Last version:            V1.0
** Descriptions:            Interrupt Handle Function
**
**--------------------------------------------------------------------------------------------------------
** Created by:              ???
** Created date:            2013-03-27
** Version:                 V1.0
** Descriptions:            The original version 
**--------------------------------------------------------------------------------------------------------
** Modified by:        
** Modified date:      
** Version:            
** Descriptions:       
**
**********************************************************************************/
#include "KL25Z_IT.h"
#include "MMA8451Q.h"
#include "Queue.h"
#include "KL25Z_GPIO.h"
extern CirQueue MMA8451QRecQ;
extern INT8U gucUSBExtractCont;
/**********************************************************************************
** Function name:           TSI0_IRQHandler
** Descriptions:            TSI??????
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              Yitao LU
** Created date:            2013-03-27
**--------------------------------------------------------------------------------------------------------
** Modified by:             
** Modified date:           
**********************************************************************************/
void TSI0_IRQHandler (void)
{
	TSI0_GENCS |= TSI_GENCS_EOSF_MASK;                                  /* TSI?????                */
	electrodeChange();
}
/**********************************************************************************
** Function name:           LPTimer_IRQHandler()
** Descriptions:            LPTMR?????? 10ms??
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              Yitao LU
** Created date:            2013-03-27
**--------------------------------------------------------------------------------------------------------
** Modified by:             
** Modified date:           
**********************************************************************************/
void LPTimer_IRQHandler (void)
{
    LPTMR0_CSR |= LPTMR_CSR_TCF_MASK;                                  /* lptmr???????          */
	TSI0_DATA  |= TSI_DATA_SWTS_MASK;                                  /* ??????                 */
	usDHTTimeCount++;
}
/**********************************************************************************
** Function name:           RTC_Seconds_IRQHandler
** Descriptions:            RTC???????
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              Yitao LU
** Created date:            2013-03-27
**--------------------------------------------------------------------------------------------------------
** Modified by:             
** Modified date:           
**********************************************************************************/
void RTC_Seconds_IRQHandler(void)
{
	rtcINTProcess();                                                    /* ???????               */
	usSystemStatusTimeCont++;
	gucUSBExtractCont++;
}
/************************************************************************************ Function name:           PORTA_IRQHandler
** Descriptions:            PORTA????????
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              Yitao LU
** Created date:            2013-03-27
**--------------------------------------------------------------------------------------------------------
** Modified by:             
** Modified date:           
**********************************************************************************/
void PORTA_IRQHandler(void)
{
	INT8U ucData[6] = {0};
	if(MMA8451Q_ReadReg(MMA845x_INT_SOURCE) & 0x01) {
		ucData[0] = MMA8451Q_ReadReg(0x01);
		ucData[1] = MMA8451Q_ReadReg(0x02);
		ucData[2] = MMA8451Q_ReadReg(0x03);
		ucData[3] = MMA8451Q_ReadReg(0x04);
		ucData[4] = MMA8451Q_ReadReg(0x05);
		ucData[5] = MMA8451Q_ReadReg(0x06);
		GPIO_TOGGLE(MKL_PORTA,12);
	}
	QueuePush(&MMA8451QRecQ, *(QueueType*)ucData);
	PORTA_ISFR = 0xFFFFFFFF;
}
/**********************************************************************************
    END FILE 
**********************************************************************************/

????3  StepCount.c
#include "StepCount.h"

CirQueue MMA8451QRecQ;
SensorData GMeter;

INT8U ucData[32] = {0};
INT16U m = 0;
INT8U n = 0;
DATATYPE DateBufferX[10] = {9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000};
DATATYPE DateBufferY[10] = {9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000};
DATATYPE DateBufferZ[10] = {9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000};
INT16U StepCount = 0;
INT8U StepFlag  = 0;
INT8U InitFlag = 0;
INT8U m_count = 0;
/**********************************************************************************
** Function name:           main
** Descriptions:            ??
**                          ??:????????????,???????????????????
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              ???
** Created Date:            2013-04-05
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**********************************************************************************/
void DataInit(SensorData *SData)
{
    SData->X.Max = -8192;
    SData->X.Min = +8192;
    SData->Y.Max = -8192;
    SData->Y.Min = +8192;
    SData->Z.Max = -8192;
    SData->Z.Min = +8192;
}
/**********************************************************************************
** Function name:           main
** Descriptions:            ??
**                          ??:????????????,???????????????????
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              ???
** Created Date:            2013-04-05
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**********************************************************************************/
unsigned char DataSelect(SensorData *GMeter)
{
    DATATYPE tempX = 0, tempY = 0, tempZ = 0, tempMax;
    INT8U flag = 0;
    tempX = GMeter->X.Max - GMeter->X.Min;
    tempY = GMeter->Y.Max - GMeter->Y.Min;
    tempZ = GMeter->Z.Max - GMeter->Z.Min;
    if(tempX > tempY) {
        if(tempX > tempZ) {
            flag = 1;
            tempMax = tempX;
        } else {
            flag = 3;
            tempMax = tempZ;
        }
    } else {
        if(tempY > tempZ) {
            flag = 2;
            tempMax = tempY;
        } else {
            flag = 3;
            tempMax = tempZ;
        }
    }
    if(tempMax > 1800) {
        return flag;
    } else {
        return 0;
    }
}
/**********************************************************************************
** Function name:           main
** Descriptions:            ??
**                          ??:????????????,???????????????????
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              ???
** Created Date:            2013-04-05
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**********************************************************************************/
void CountStepInit(void)
{
    PORT_ENABLE_CLK(MKL_PORTA);                                         /* ??PORT??                 */
    PORT_ENABLE_CLK(MKL_PORTB);
    PORT_ENABLE_CLK(MKL_PORTC);    
    PORT_ENABLE_CLK(MKL_PORTD);
    PORT_ENABLE_CLK(MKL_PORTE);
    uart0Init(115200,0,0,8,1);
    printf("MCU start\r\n");
	//printf("%d\r\n", MMA8451Q_ReadReg(0x0D));
    MMA8451Q_Init();
    init_NRF24L01();
	QueueSetNull(&MMA8451QRecQ);
    DataInit(&GMeter);
}
/**********************************************************************************
** Function name:           main
** Descriptions:            ??
**                          ??:????????????,???????????????????
** input parameters:        none
** output parameters:       none
** Returned value:          none
** Created by:              ???
** Created Date:            2013-04-05
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**********************************************************************************/
void CountStep(void)
{
	unsigned char i = 0;
    INT16S X = 0, Y = 0, Z = 0;
    QueueType Rec;
    if(!QueueIsEmpty(&MMA8451QRecQ)) {
        QueuePop(&MMA8451QRecQ, &Rec);
        for(i = 0; i < 6; i++) {
            ucData[i] = Rec.Array[i];
        }
        ucData[6] = StepCount;
        X = ((ucData[0] << 8) | ucData[1]);
        X = X / 4;
        Y = ((ucData[2] << 8) | ucData[3]);
        Y = Y / 4;
        Z = ((ucData[4] << 8) | ucData[5]);
        Z = Z / 4;
        //Angle_ControlRGB(X, Y, Z);
        if(m == DATASIZE) {
            m = 0;
            if(m_count == 0) {
                m_count = 1;
            }
        }
        if(n == 10) {
            n = 0;
        }
        DateBufferX[n] = X;
        DateBufferY[n] = Y;
        DateBufferZ[n] = Z;
        if(InitFlag < 9) {
            GMeter.X.Data[m] = X;
            GMeter.Y.Data[m] = Y;
            GMeter.Z.Data[m] = Z;
            InitFlag++;
        } else {
            GMeter.X.Data[m] = (DateBufferX[0] + DateBufferX[1] + DateBufferX[2] + DateBufferX[3] + DateBufferX[4] + DateBufferX[5] + DateBufferX[6] + DateBufferX[7] + DateBufferX[8] + DateBufferX[9]) / 10;
            GMeter.Y.Data[m] = (DateBufferY[0] + DateBufferY[1] + DateBufferY[2] + DateBufferY[3] + DateBufferY[4] + DateBufferY[5] + DateBufferY[6] + DateBufferY[7] + DateBufferY[8] + DateBufferY[9]) / 10;
            GMeter.Z.Data[m] = (DateBufferZ[0] + DateBufferZ[1] + DateBufferZ[2] + DateBufferZ[3] + DateBufferZ[4] + DateBufferZ[5] + DateBufferZ[6] + DateBufferZ[7] + DateBufferZ[8] + DateBufferZ[9]) / 10;
        }
        if(m_count == 1) {
            if(GMeter.X.MaxMark == m || GMeter.X.MinMark == m || GMeter.Y.MaxMark == m || GMeter.Y.MinMark == m || GMeter.Z.MaxMark == m || GMeter.Z.MinMark == m) {
                INT8U tempXMaxMark = GMeter.X.MaxMark;
                INT8U tempXMinMark = GMeter.X.MinMark;
                INT8U tempYMaxMark = GMeter.Y.MaxMark;
                INT8U tempYMinMark = GMeter.Y.MinMark;
                INT8U tempZMaxMark = GMeter.Z.MaxMark;
                INT8U tempZMinMark = GMeter.Z.MinMark;
                if(GMeter.X.MaxMark == m) {
                    GMeter.X.Max = -8192;
                }
                if(GMeter.X.MinMark == m) {
                    GMeter.X.Min = +8192;
                }
                if(GMeter.Y.MaxMark == m) {
                    GMeter.Y.Max = -8192;
                }
                if(GMeter.Y.MinMark == m) {
                    GMeter.Y.Min = +8192;
                }
                if(GMeter.Z.MaxMark == m) {
                    GMeter.Z.Max = -8192;
                }
                if(GMeter.Z.MinMark == m) {
                    GMeter.Z.Min = +8192;
                }
                for(i = 0; i < DATASIZE; i++) {
                    if(GMeter.X.MaxMark == m) {
                        if(GMeter.X.Data[i] >= GMeter.X.Max) {
                            GMeter.X.Max = GMeter.X.Data[i];
                            tempXMaxMark = i;
                        }
                    }
                    if(GMeter.X.MinMark == m) {
                        if(GMeter.X.Data[i] <= GMeter.X.Min) {
                            GMeter.X.Min = GMeter.X.Data[i];
                            tempXMinMark = i;
                        }
                    }
                    if(GMeter.Y.MaxMark == m) {
                        if(GMeter.Y.Data[i] >= GMeter.Y.Max) {
                            GMeter.Y.Max = GMeter.Y.Data[i];
                            tempYMaxMark = i;
                        }
                    }
                    if(GMeter.Y.MinMark == m) {
                        if(GMeter.Y.Data[i] <= GMeter.Y.Min) {
                            GMeter.Y.Min = GMeter.Y.Data[i];
                            tempYMinMark = i;
                        }
                    }
                    if(GMeter.Z.MaxMark == m) {
                        if(GMeter.Z.Data[i] >= GMeter.Z.Max) {
                            GMeter.Z.Max = GMeter.Z.Data[i];
                            tempZMaxMark = i;
                        }
                    }
                    if(GMeter.Z.MinMark == m) {
                        if(GMeter.Z.Data[i] <= GMeter.Z.Min) {
                            GMeter.Z.Min = GMeter.Z.Data[i];
                            tempZMinMark = i;
                        }
                    }
                }
                GMeter.X.MaxMark = tempXMaxMark;
                GMeter.X.MinMark = tempXMinMark;
                GMeter.Y.MaxMark = tempYMaxMark;
                GMeter.Y.MinMark = tempYMinMark;
                GMeter.Z.MaxMark = tempZMaxMark;
                GMeter.Z.MinMark = tempZMinMark;
            }
        }
        if(GMeter.X.Data[m] >= GMeter.X.Max) {
            GMeter.X.Max = GMeter.X.Data[m];
            GMeter.X.MaxMark = m;
        }
        if(GMeter.X.Data[m] <= GMeter.X.Min) {
            GMeter.X.Min = GMeter.X.Data[m];
            GMeter.X.MaxMark = m;
        }
        if(GMeter.Y.Data[m] >= GMeter.Y.Max) {
            GMeter.Y.Max = GMeter.Y.Data[m];
            GMeter.Y.MaxMark = m;
        }
        if(GMeter.Y.Data[m] <= GMeter.Y.Min) {
            GMeter.Y.Min = GMeter.Y.Data[m];
            GMeter.Y.MinMark = m;
        }
        if(GMeter.Z.Data[m] >= GMeter.Z.Max) {
            GMeter.Z.Max = GMeter.Z.Data[m];
            GMeter.Z.MaxMark = m;
        }
        if(GMeter.Z.Data[m] <= GMeter.Z.Min) {
            GMeter.Z.Min = GMeter.Z.Data[m];
            GMeter.Z.MinMark = m;
        }
        GMeter.X.Base      = (GMeter.X.Max + GMeter.X.Min) / 2;
        GMeter.Y.Base      = (GMeter.Y.Max + GMeter.Y.Min) / 2;
        GMeter.Z.Base      = (GMeter.Z.Max + GMeter.Z.Min) / 2;
        GMeter.X.UpLimit   = (GMeter.X.Base + GMeter.X.Max * 2) / 3;
        GMeter.Y.UpLimit   = (GMeter.Y.Base + GMeter.Y.Max * 2) / 3;
        GMeter.Z.UpLimit   = (GMeter.Z.Base + GMeter.Z.Max * 2) / 3;
        GMeter.X.DownLimit = (GMeter.X.Base + GMeter.X.Min * 2) / 3;
        GMeter.Y.DownLimit = (GMeter.Y.Base + GMeter.Y.Min * 2) / 3;
        GMeter.Z.DownLimit = (GMeter.Z.Base + GMeter.Z.Min * 2) / 3;
        switch(DataSelect(&GMeter)) {
        case 1:
            if((GMeter.X.Data[m] > GMeter.X.UpLimit) && StepFlag == 0) {
                StepFlag = 1;
            }
            if((GMeter.X.Data[m] < GMeter.X.DownLimit) && StepFlag ==1) {
                StepFlag = 0;
                StepCount++;
            }
            break;
        case 2:
            if((GMeter.Y.Data[m] > GMeter.Y.UpLimit) && StepFlag == 0) {
                StepFlag = 1;
            }
            if((GMeter.Y.Data[m] < GMeter.Y.DownLimit) && StepFlag ==1) {
                StepFlag = 0;
                StepCount++;
            }
            break;
        case 3:
            if((GMeter.Z.Data[m] > GMeter.Z.UpLimit) && StepFlag == 0) {
                StepFlag = 1;
            }
            if((GMeter.Z.Data[m] < GMeter.Z.DownLimit) && StepFlag ==1) {
                StepFlag = 0;
                StepCount++;
            }
            break;
        default:
            break;
        }
        ucData[6]   = GMeter.X.Data[m] >> 8;
        ucData[7]   = GMeter.X.Data[m] & 0x00FF;
        ucData[8]   = GMeter.Y.Data[m] >> 8;
        ucData[9]   = GMeter.Y.Data[m] & 0x00FF;
        ucData[10]  = GMeter.Z.Data[m] >> 8;
        ucData[11]  = GMeter.Z.Data[m] & 0x00FF;
        ucData[12]  = GMeter.Z.Base >> 8;
        ucData[13]  = GMeter.Z.Base & 0x00FF;
        ucData[14]  = GMeter.Z.UpLimit >> 8;
        ucData[15]  = GMeter.Z.UpLimit & 0x00FF;
        ucData[16]  = GMeter.Z.DownLimit >> 8;
        ucData[17]  = GMeter.Z.DownLimit & 0x00FF;
        ucData[18]  = GMeter.Z.Max >> 8;
        ucData[19]  = GMeter.Z.Max & 0x00FF;
        ucData[20]  = GMeter.Z.Min >> 8;
        ucData[21]  = GMeter.Z.Min & 0x00FF;
        ucData[22]  = StepCount;
        ucData[23]  = StepFlag;
        m++;
        n++;
        UartSendPacket(ucData, 32);
        nRF24L01_TxPacket(ucData);
        SPI_RW_Reg(WRITE_REG+STATUS,0XFF);
    }
//	UartSendPacket(ucData, 32);
}
/**********************************************************************************
** Function name:           myDelay
** Descriptions:            ????
** input parameters:        ulTime:????
** output parameters:       none
** Returned value:          none
** Created by:              Li Xiang
** Created Date:            2012-12-14
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**********************************************************************************/
void UartSendPacket(INT8U *ucData, INT8U ucSize)
{
	INT8U ucTemp[50] = {0};
	unsigned char temp = 0, i = 0;
	ucTemp[0] = 0xAA;
	ucTemp[1] = 0x55;
	ucTemp[2] = ucSize;
	for(i = 0; i < ucSize; i++) {
		ucTemp[i + 3] = ucData[i];
	}
	for(i = 0; i < ucSize + 3; i++) {
		temp ^= ucTemp[i];
	}
	ucTemp[ucSize + 3] = temp;
	for(i = 0; i < ucSize + 4; i++) {
		uart0SendChar(ucTemp[i]);
	}
}
void Distance(CM  *gConfigMsg, DM *gDataManager)
{
    gDataManager->dDistance = gConfigMsg->ucStepLen * gDataManager->usStepNum;
}
void GetEnergy(CM  *gConfigMsg, DM *gDataManager)
{
    gDataManager->uiCalorie = gDataManager->usStepNum * gConfigMsg->ucWeight / 400;
}